diff -u arc2/strings.arc arc3/strings.arc
--- arc2/strings.arc	2008-02-24 19:53:13.000000000 -0500
+++ arc3/strings.arc	2009-05-30 17:09:15.000000000 -0400
@@ -8,13 +8,41 @@
 ;"\u0085"
 
 (def tokens (s (o sep whitec))
-  (let test (if (isa sep 'fn) sep (fn (c) (is c sep)))
+  (let test (testify sep)
     (let rec (afn (cs toks tok)
                (if (no cs)         (consif tok toks)
                    (test (car cs)) (self (cdr cs) (consif tok toks) nil)
                                    (self (cdr cs) toks (cons (car cs) tok))))
-    (rev (map [coerce _ 'string]
-              (map rev (rec (coerce s 'cons) nil nil)))))))
+      (rev (map [coerce _ 'string]
+                (map rev (rec (coerce s 'cons) nil nil)))))))
+
+; names of cut, split, halve not optimal
+
+(def halve (s (o sep whitec))
+  (let test (testify sep)
+    (let rec (afn (cs tok)
+               (if (no cs)         (list (rev tok))
+                   (test (car cs)) (list cs (rev tok))
+                                   (self (cdr cs) (cons (car cs) tok))))
+      (rev (map [coerce _ 'string]
+                (rec (coerce s 'cons) nil))))))
+
+; maybe promote to arc.arc, but if so include a list clause
+
+(def positions (test seq)
+  (accum a
+    (let f (testify test)
+      (forlen i seq
+        (if (f (seq i)) (a i))))))
+
+(def lines (s)
+  (accum a
+    ((afn ((p . ps))
+       (if ps
+           (do (a (rem #\return (cut s (+ p 1) (car ps))))
+               (self ps))
+           (a (cut s (+ p 1)))))
+     (cons -1 (positions #\newline s)))))
 
 ; > (require (lib "uri-codec.ss" "net"))
 ;> (form-urlencoded-decode "x%ce%bbx")
@@ -30,12 +58,18 @@
     (caselet c (s i)
       #\+ (writec #\space)
       #\% (do (when (> (- (len s) i) 2)
-                (let code (coerce (cut s (+ i 1) (+ i 3))
-                                  'int 16)
-                  (writeb code)))
+                (writeb (int (cut s (+ i 1) (+ i 3)) 16)))
               (++ i 2))
           (writec c)))))
 
+(def urlencode (s)
+  (tostring 
+    (each c s 
+      (writec #\%)
+      (let i (int c)
+        (if (< i 16) (writec #\0))
+        (pr (coerce i 'string 16))))))
+
 (mac litmatch (pat string (o start 0))
   (w/uniq (gstring gstart)
     `(with (,gstring ,string ,gstart ,start)
@@ -69,7 +103,7 @@
     (if (isa pat 'fn)
         (for i start (- (len seq) 1)
           (when (pat (seq i)) (throw i)))
-        (for i start (- (len seq) (- (len pat) 2))
+        (for i start (- (len seq) (len pat))
           (when (headmatch pat seq i) (throw i))))
     nil))
 
@@ -113,6 +147,8 @@
 
 (def blank (s) (~find ~whitec s))
 
+(def nonblank (s) (unless (blank s) s))
+
 (def trim (s where (o test whitec))
   (withs (f   (testify test)
            p1 (pos ~f s))
@@ -126,40 +162,52 @@
                  (+ i 1))))
         "")))
 
-(def num (m (o digits 2) (o trail-zeros nil) (o init-zero nil))
-  (let comma
-       (fn (i)
-         (tostring
-           (map [apply pr (rev _)]
-                (rev (intersperse '(#\,)
-                                  (tuples (rev (coerce (string i) 'cons))
-                                          3))))))
-    (if (< digits 1)
-         (comma (roundup m))
-        (exact m)
-         (string (comma m)
-                 (when (and trail-zeros (> digits 0))
-                   (string "." (newstring digits #\0))))
-         (withs (d (expt 10 digits)
-                 n (/ (roundup (* m d)) d)
-                 i (trunc n))
-           (+ (if (is i 0) (if init-zero "0" "") (comma i))
-              (withs (rest   (string (abs (trunc (- (* n d) (* i d)))))
-                      padded (+ (newstring (- digits (len rest)) #\0)
-                                rest)
-                      final  (if trail-zeros
-                                 padded
-                                 (trim padded 'end [is _ #\0])))
-                (string (unless (empty final) ".")
-                        final)))))))
+(def num (n (o digits 2) (o trail-zeros nil) (o init-zero nil))
+  (withs (comma
+          (fn (i)
+            (tostring
+              (map [apply pr (rev _)]
+                   (rev (intersperse '(#\,)
+                                     (tuples (rev (coerce (string i) 'cons))
+                                             3))))))
+          abrep
+          (let a (abs n)
+            (if (< digits 1)
+                 (comma (roundup a))
+                (exact a)
+                 (string (comma a)
+                         (when (and trail-zeros (> digits 0))
+                           (string "." (newstring digits #\0))))
+                 (withs (d (expt 10 digits)
+                         m (/ (roundup (* a d)) d)
+                         i (trunc m)
+                         r (abs (trunc (- (* m d) (* i d)))))
+                   (+ (if (is i 0) 
+                          (if (or init-zero (is r 0)) "0" "") 
+                          (comma i))
+                      (withs (rest   (string r)
+                              padded (+ (newstring (- digits (len rest)) #\0)
+                                        rest)
+                              final  (if trail-zeros
+                                         padded
+                                         (trim padded 'end [is _ #\0])))
+                        (string (unless (empty final) ".")
+                                final)))))))
+    (if (and (< n 0) (find [and (digit _) (isnt _ #\0)] abrep))
+        (+ "-" abrep)
+        abrep)))
+        
 
 ; English
 
-(def plural (n str)
+(def pluralize (n str)
   (if (or (is n 1) (single n))
       str
       (string str "s")))
-          
+
+(def plural (n x)
+  (string n #\  (pluralize n x)))
+
 
 ; http://www.eki.ee/letter/chardata.cgi?HTML4=1
 ; http://jrgraphix.net/research/unicode_blocks.php?block=1
Only in arc2: y18.gif
